import { Injectable } from '@angular/core';
import { HttpClient } from "@angular/common/http";
import { AlertController, App, Events, LoadingController, Platform } from "ionic-angular";
import { HTTP } from "@ionic-native/http";
var MyProvider = /** @class */ (function () {
    function MyProvider(httpClient, alertCtrl, app, loadingCtrl, events, nativeHttp, platform) {
        this.httpClient = httpClient;
        this.alertCtrl = alertCtrl;
        this.app = app;
        this.loadingCtrl = loadingCtrl;
        this.events = events;
        this.nativeHttp = nativeHttp;
        this.platform = platform;
        this._address = ":9997";
        this.debug = "";
        this.port = "9997";
    }
    MyProvider.prototype.myMethod = function () {
        console.log("I'm afraid I can't do that.");
    };
    MyProvider.prototype.getUrl = function () {
        var address = "";
        // if(this.port =="9998"){
        //   localStorage.setItem("ipAddress","http://weiapp.pw")
        //   // localStorage.setItem("ipAddress","http://113.229.123.104")
        //   localStorage.setItem("port",":9998")
        // }else if(this.port =="9997"){
        localStorage.setItem("ipAddress", "http://weiapp.pw");
        // localStorage.setItem("ipAddress","http://113.229.123.104")
        localStorage.setItem("port", ":9997");
        // }
        // localStorage.setItem("ipAddress","http://sulixin.qicp.vip")
        // // localStorage.setItem("ipAddress","http://113.229.123.104")
        // localStorage.setItem("port",":80")
        address = localStorage.getItem("ipAddress") + localStorage.getItem("port"); //外网 测试
        localStorage.setItem("address", address);
        var strUrl = address + "/contract";
        return strUrl;
    };
    MyProvider.prototype.postData = function (url, body, successCallback, isLoading, errorCallback) {
        var _this = this;
        var loading = this.loadingCtrl.create({
            content: "请等待...",
        });
        if (isLoading) {
            loading.present();
        }
        var headers = new Headers();
        headers.append('Content-Type', 'application/x-www-form-urlencoded;charset=UTF-8');
        headers.append('type', 'app');
        // alert(this.platform.is("mobileweb"))
        if (!this.platform.is("mobileweb")) {
            this.nativeHttp.setDataSerializer('urlencoded');
            this.nativeHttp.post(url, body, { type: "app" })
                .then(function (data) {
                if (isLoading) {
                    loading.dismiss();
                }
                // if(data.data.toString().indexOf("login.jsp")){
                //   this.errorCallback( "登录超时，请重新登录");
                //   this.events.publish("toLogin")
                //   return;
                // }
                var res = JSON.parse(data.data);
                if (successCallback) {
                    if (res["success"] == "true" || res["success"] == "success" || res["success"]) {
                        successCallback(res);
                        // alert("success")
                    }
                    else {
                        if (res['msg'] == "-2") {
                            _this.errorCallback("登录超时，请重新登录");
                            _this.events.publish("toLogin");
                            // if (localStorage.getItem("userCode")){
                            //   this.postData(this.getUrl()+"/api/v1/login/login.do", {userCode:localStorage.getItem("userCode"),password:localStorage.getItem("password")},(data)=>{
                            //     this.postData(url,body,successCallback,false,errorCallback)
                            //   }, false)
                            // }
                        }
                        else {
                            if (errorCallback) {
                                errorCallback(res['msg']);
                            }
                            else {
                                _this.errorCallback(res['msg']);
                            }
                        }
                    }
                }
            })
                .catch(function (error) {
                if (isLoading) {
                    loading.dismiss();
                }
                var errMsg = "网络通信异常";
                switch (error.status) {
                    case 401:
                        errMsg = "登录超时，请重新登录";
                        break;
                    case 404:
                        errMsg = '抱歉，后台服务找不到对应接口';
                        break;
                    case 0:
                        errMsg = '网络无法连接';
                    default:
                        break;
                }
                if (errMsg != "") {
                    if (errorCallback) {
                        errorCallback(errMsg);
                    }
                    else {
                        _this.errorCallback(errMsg);
                    }
                }
            });
        }
        else {
            var options = {
                headers: { 'Content-Type': 'application/x-www-form-urlencoded;charset=UTF-8',
                    'type': 'app' },
                withCredentials: true
            };
            this.httpClient.post(url, this.transformRequest(body), options).subscribe(function (res) {
                console.log(res);
                if (isLoading) {
                    loading.dismiss();
                }
                if (successCallback) {
                    if (res["success"] == "true" || res["success"] == "success" || res["success"]) {
                        successCallback(res);
                    }
                    else {
                        if (res['msg'] == "-2") {
                            _this.errorCallback("登录超时，请重新登录");
                            _this.events.publish("toLogin");
                            // if (localStorage.getItem("userCode")){
                            //   this.postData(this.getUrl()+"/api/v1/login/login.do", {userCode:localStorage.getItem("userCode"),password:localStorage.getItem("password")},(data)=>{
                            //     this.postData(url,body,successCallback,false,errorCallback)
                            //   }, false)
                            // }
                        }
                        else {
                            if (errorCallback) {
                                errorCallback(res['msg']);
                            }
                            else {
                                _this.errorCallback(res['msg']);
                            }
                        }
                    }
                }
            }, function (err) {
                if (isLoading) {
                    loading.dismiss();
                }
                var errMsg = "网络通信异常";
                switch (err.status) {
                    case 401:
                        errMsg = "登录超时，请重新登录";
                        break;
                    case 404:
                        errMsg = '抱歉，后台服务找不到对应接口';
                        break;
                    case 0:
                        errMsg = '网络无法连接';
                    default:
                        break;
                }
                if (errMsg != "") {
                    if (errorCallback) {
                        errorCallback(errMsg);
                    }
                    else {
                        _this.errorCallback(errMsg);
                    }
                }
            });
        }
    };
    ;
    MyProvider.prototype.transformRequest = function (obj) {
        var str = [];
        for (var s in obj) {
            str.push(encodeURIComponent(s) + "=" + encodeURIComponent(obj[s]));
        }
        return str.join("&");
    };
    MyProvider.prototype.errorCallback = function (msg) {
        var alertCtrl = this.alertCtrl.create({
            title: msg
        });
        alertCtrl.present();
    };
    MyProvider.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    MyProvider.ctorParameters = function () { return [
        { type: HttpClient, },
        { type: AlertController, },
        { type: App, },
        { type: LoadingController, },
        { type: Events, },
        { type: HTTP, },
        { type: Platform, },
    ]; };
    return MyProvider;
}());
export { MyProvider };
//# sourceMappingURL=my-provider.js.map